package com.demo;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PiePlot;

import org.jfree.data.general.PieDataset;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;

public class PieChartExploded extends ApplicationFrame
{
	private static final long serialVersionUID = 1L;
	
	PieDataset dataset = Dataset.createPieDataset(Dataset.EXPENSES_05);
	JFreeChart chart = createChart(dataset);
	
	public PieChartExploded(final String title) 
	{
		 super(title);
		 dataset = Dataset.createPieDataset(Dataset.EXPENSES_05);
		 chart = createChart(dataset);

		 // Размещение диаграммы в панели
		 final ChartPanel chartPanel = new ChartPanel(chart);
		 chartPanel.setPreferredSize(new java.awt.Dimension(600, 400));
		 setContentPane(chartPanel);
	 }
	 private JFreeChart createChart(final PieDataset dataset)
	 {
		 chart = ChartFactory.createPieChart("Диаграмма расходов",
			                          dataset, true, true, false);
		 PiePlot plot = (PiePlot) chart.getPlot();
//		 plot.setNoDataMessage("No data available");
		 plot.setExplodePercent(Dataset.SECTIONS[3], 0.20);
		 return chart;
	 }
	 public static void main(final String[] args)
	 {
		 PieChartExploded demo = new PieChartExploded("Pie Chart");
		 demo.pack();
		 RefineryUtilities.centerFrameOnScreen(demo);
		 demo.setVisible(true);
	 }
}
