package com.demo;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.text.NumberFormat;

import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PiePlot;
import org.jfree.chart.plot.PiePlot3D;
import org.jfree.chart.labels.PieSectionLabelGenerator;
import org.jfree.chart.labels.StandardPieSectionLabelGenerator;

import org.jfree.data.general.PieDataset;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;

public class PieChartMulti extends ApplicationFrame
{
	private static final long serialVersionUID = 1L;
	
	PieDataset   dataset_05 = null;
	PieDataset   dataset_06 = null;
	JFreeChart   chart1     = null;
	JFreeChart   chart2     = null;
	JFreeChart   chart3     = null;
	JFreeChart   chart4     = null;
	PieSectionLabelGenerator
	             pslg       = null;

	boolean      chart3d    = true;
	public PieChartMulti(String title) 
	{
		super(title);
		JPanel panel = new JPanel(new GridLayout(2, 1));
		// Создание наборов данных
		dataset_05 = Dataset.createPieDataset(Dataset.EXPENSES_05);
		dataset_06 = Dataset.createPieDataset(Dataset.EXPENSES_06);

		// Создание диаграмм
		if (!chart3d) {
			chart1 = ChartFactory.createPieChart("Диаграмма расходов,  май" , dataset_05, false, false, false);
			PiePlot plot1 = (PiePlot) chart1.getPlot();
			// Добавим в метку фактическое значение секции
			pslg = new StandardPieSectionLabelGenerator("{0} = {1}", 
		               NumberFormat.getNumberInstance(), 
                       NumberFormat.getPercentInstance());
			plot1.setLabelGenerator(pslg);
			plot1.setLabelGap(0.02); 
			
			chart2 = ChartFactory.createPieChart("Диаграмма расходов,  июнь", dataset_06, false, false, false);
			PiePlot plot2 = (PiePlot) chart2.getPlot();
			plot2.setCircular(false);

			plot2.setInteriorGap(0.0);
	        plot2.setLabelGenerator(null);

			// Размещение диаграмм на панели ChartPanel
			panel.add(new ChartPanel(chart1));
			panel.add(new ChartPanel(chart2));
		} else {
			chart3 = ChartFactory.createPieChart3D("Диаграмма расходов,  май", dataset_05, false, false, false);
			PiePlot3D plot3 = (PiePlot3D) chart3.getPlot();
			plot3.setForegroundAlpha(0.6f);
			plot3.setCircular(true);
			// Добавим в метку %-соотношение от общей суммы 
			pslg = new StandardPieSectionLabelGenerator("{0} = {2}", 
		                           NumberFormat.getNumberInstance(), 
                                  NumberFormat.getPercentInstance());
			plot3.setLabelGenerator(pslg);
		
			chart4 = ChartFactory.createPieChart3D("Диаграмма расходов,  июнь", dataset_06, false, false, false);
			PiePlot3D plot4 = (PiePlot3D) chart4.getPlot();
			plot4.setForegroundAlpha(0.6f);
	        plot4.setLabelGenerator(null);

	        // Размещение диаграмм на панели ChartPanel
			panel.add(new ChartPanel(chart3));
			panel.add(new ChartPanel(chart4));
		}

		panel.setPreferredSize(new Dimension(540, 480));
		setContentPane(panel);
	 }
	 public static void main(String[] args)
	 {
		 PieChartMulti demo = new PieChartMulti("Pie Chart");
		 demo.pack();
		 RefineryUtilities.centerFrameOnScreen(demo);
		 demo.setVisible(true);
	 }
}
